# Pico Motor Shim MicroPython Examples <!-- omit in toc -->

- [Examples](#examples)
  - [Single Motor](#single-motor)
  - [Dual Motors](#dual-motors)
  - [Movements](#movements)
  - [Motor Song](#motor-song)
  - [Stop Motors](#stop-motors)


## Examples

### Single Motor
[single_motor.py](single_motor.py)

Demonstrates how to create a Motor object and control it.


### Dual Motors
[dual_motors.py](dual_motors.py)

Demonstrates how to create two Motor objects and control them together.


### Movements
[movements.py](movements.py)

An example of how to perform simple movements of a 2-wheeled driving robot.


### Motor Song
[motor_song.py](motor_song.py)

A fun example of how to change a motor's frequency to have it play a song.


### Stop Motors
[stop_motors.py](stop_motors.py)

A simple program that stops the motors.
