# Setting up MicroPython

If you just want to use MicroPython then setup is a breeze as we've already built the firmware for you and you can simply drag it onto your Pico to get started.

If you want to use our products with your Raspberry Pi Pico then you must use our pre-built firmware as it contains all of the drivers needed.

To setup your Raspberry Pi Pico with our MicroPython firmware follow these steps:

## Step 1
Disconnect the USB cable from your Raspberry Pi Pico.

## Step 2
Press and hold the "BOOTSEL" switch on top of the Raspberry Pi Pico.

## Step 3
Plug the USB cable back into your Raspberry Pi Pico (making sure to keep the "BOOTSEL" button pressed while you do it!).

This should put your Raspberry Pi Pico into firmware update mode. It will appear as a new disk drive on your computer with the name **RPI-RP2**.

## Step 4
Download our custom MicroPython firmware image from [the releases page](https://github.com/pimoroni/pimoroni-pico/releases).

## Step 5
Copy the downloaded firmware image onto the **RPI-RP** drive.

The firmware will now upload to your Raspberry Pi Pico and when it has finished uploading (which takes around five seconds) the Pico will restart itself.

Hurrah! You're setup and good to go!
